拥抱.NET Core,学习.NET Core的基础知识补遗

前言

.NET Core的新特性之一就是跨平台,但由于对之前框架的兼容导致编写一个.NET Core类库变得相当复杂,主要体现为相当多的框架目标和支持平台,今天我们就对.NET Core的跨平台特性进行一次梳理。

在.NET Core之前

其实早在.NET Core之前微软就有推出.NET的跨平台方案,不过这次的跨平台指的不是Linux、OSX,而是微软自家的平台,如:NET、Silverlight、Windows8、Windows8.1、Windows Phone。

这个阶段微软将它称作为:可移植类库

下面是可移植类库的配置界面

image

在这个阶段.NET开发就出现了分歧,类库项目也分成了两个:类库、可移植类库。

image

从理论上来说,可移植类库由于类库,因为它是真正意义上的统一类库,但现实情况是大部分开发人员都选择使用类库而不是可移植类库。

然而困难从此就开始生根(如果微软之前统一了这两个项目现在的情况或许会好很多)。

在.NET Core起步

第一阶段(Project K)

KRE(K Runtime Environment)

KVM(K Version Manager)

KPM(K Package Manager)

K / KLR(K runtime / K language runtime (not sure))

这个阶段到还好,很多东西刚接触.NET Core的人可能根本没有听过,因为早早的被废弃,所以影响不是很大。

第二阶段(DNX)

DNX451

DNXCORE50

到这个阶段微软和一些第三方已经开始着手进行支持了。

第三阶段(DOTNET5.0)

dotnet5.4

dotnet50

畅言

由此可以看到微软改名部的强大。这里不是在摒弃开发团队,而是这些动作为之后留下了复杂知识体系。

因为这个阶段.NET Core已经发展了很长时间,也有很多第三方开始编写支持的组件,为以后的兼容留下了隐患。

.NET Core 1.0

在这个版本微软真正确定了.NET Core(netcoreapp)的命名,并推出了.NET Platform Standard(netstandard .NET标准)。

.NET Core兼容.NET Platform Standard1.6(netstandard .16)。

从此统一了开发模型,开发类库时不在需要关心项目模型,因为.NET Core支持全平台。

但为了兼容,Visual Studio还是保留了类库、可移植类库的项目模板。但推荐大家以后都使用.NET Core的类库项目模版进行组件开发。

.NET平台

官方给出了一张表

image

目前一起有9个平台,其中 Windows Phone、Silverlight停止更新就还剩下7个平台。

.NET Platform Standard

为什么推出?

现有的平台已经够多了,为什么还再推出一个新平台?

目标

  1. 提供更好的可移植性在未来的.NET版本中
  2. 更容易理解平台版本

简单的说就是,微软觉得.NET平台太多了,想进行统一从而推出了netstandard。

大家可以将netstandard理解为一个公共类库,不同的平台可以兼容这个公共类库。

兼容关系

netstandard的兼容

在以前的.NET Framework中API几乎都是向下兼容的,也就是说.NET3.5兼容.NET2.0、.NET4兼容.NET3.5,具体的层次如下:

2.x < 3.x < 4.x

netstandard也是一样。

1.0 < 1.1 < 1.2 < 1.3 < 1.4 < 1.5 < 1.6

平台之间的兼容

对照上表netstandard支持的最低.net framework版本是4.5,也就是说.net4.5 支持netstandard1.1和以后的版本。

举个例子(按照这个例子可以清楚的看懂上表的关系)

如果你开发的类库配置为netstandard1.3,那么可以使用的平台有:

  1. .NET Framework4.6及以后的版本(4.6,4.6.1,4.6.2,4.6.3)
  2. .NET Core 1.0及以后的版本
  3. Universal Windows Platform 10.0及以后的版本
  4. Mono/Xamarin Platforms

开发环境

Visual Studio(推荐使用)

ps:如果已经安装了 vs2015 update3 在安装.NET Core 1.0.0 - VS 2015 Tooling Preview 2时还是提示没有安装update3,可以使用“SKIP_VSU_CHECK=1”这个参数忽略vs的检查。

在命令行使用:“DotNetCore.1.0.0-VS2015Tools.Preview2.exe SKIP_VSU_CHECK=1”进行安装。

Visual Studio Code

参考资料

https://www.microsoft.com/net/core

FAQ

支持.NET4之前的版本吗?

支持,只不过.NET4之前的版本没有对.NET Platform Standard进行兼容,可以单独设置兼容.NET4,.NET3.5等。

使用.NET Core就一定可以跨平台吗?

不一定,只有完全使用兼容.NET Platform Standard的类库才可以跨平台运行。

包还原失败怎么办?

包还原失败一般有两种情况。

1.依赖的版本不对,比如框架目标为.netstandard1.6,依赖的包只支持.net45这样包就无法解析。

2.网络问题,重试或FQ。

如何在旧项目上使用.NET Core相关的组件,如:依赖注入,日志?

使用.net4.6,可以兼容很大部分现代化组件。.net版本越高兼容的就越多。

写在最后

这篇博文的主题本应该叫:拥抱.NET Core,开发第一个跨平台类库(DbUtils),后面又改成:拥抱.NET Core,开发第一个跨平台类库(1),而在撰写过程中发现内容实在太多了,顾拆成了多个部分,今天先讲一些基础概念,后面在写如何开发一个跨平台类库。

ps:实践型文章虽然很好看但还是推荐大家多阅读理论文章,比较熟悉了原理其它的都很简单,可以举一反三。

posted @ 2016-08-04 15:08 KAnts 阅读(...) 评论(...) 编辑 收藏